package com.njcn.csdevice.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csdevice.api.DevModelFeignClient;
import com.njcn.csdevice.pojo.param.CsDevModelAddParm;
import com.njcn.csdevice.pojo.param.CsDevModelQueryListParm;
import com.njcn.csdevice.pojo.po.CsDevModelPO;
import com.njcn.csdevice.pojo.vo.CsDevModelPageVO;
import com.njcn.csdevice.utils.CsDeviceEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2023/4/10 20:09
 */
@Slf4j
@Component
public class DevModelFeignClientFallbackFactory implements FallbackFactory<DevModelFeignClient> {
    @Override
    public DevModelFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
            exceptionEnum = CsDeviceEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new DevModelFeignClient() {

            @Override
            public HttpResult<CsDevModelPO> addDevModel(CsDevModelAddParm csDevModelAddParm) {
                log.error("{}异常，降级处理，异常为：{}","新增装置模板版本信息",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<CsDevModelPageVO> queryDevModelOne(CsDevModelQueryListParm csDevModelQueryListParm) {
                log.error("{}异常，降级处理，异常为：{}","查询模板版本信息",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<CsDevModelPO> findModel(String devType, String version, String time) {
                log.error("{}异常，降级处理，异常为：{}","根据条件查询模板",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<CsDevModelPO> getModelById(String id) {
                log.error("{}异常，降级处理，异常为：{}","根据id查询模板",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
